function [m,d] = fdcm(Y,X,u,v,h,kern1,g,kern2)

if (nargin < 7) %
    g = h; kern2=kern1;
end

[n,j] = size(X);
J = j+1; 

k = length(v);
m = zeros(k,1);
d = zeros(k,j);
for i=1:k
    phi = X - ones(n,1)*[u v(i,:)]; % n by j
    W = prod([feval(kern1,(phi(:,1)/h)) feval(kern2,(phi(:,2:j)/g))],2)/(h*g^(j-1));
    W1 = repmat(W,1,j).*phi; % 
    S11 = sum(W);
    S12 = sum(W1);
    S22 = W1'*phi; % j by j
    S = [S11 S12;S12' S22];
    D1 = W.*Y; % n by 1
    D = [sum(D1);phi'*D1];
    if rcond(S)<1e-15
        m1 = (1e-8*eye(J)+S)\D;
    else
        m1 = S\D;
    end
    m(i) = m1(1);
    d(i,:) = m1(2:J)';
end


