function h = fdllh(Y,X,N,x,sa)
% This is to find feasible optimal window width
%
if (nargin < 5 || isempty(sa)) %
    sa = 1;
end
kernel = @normpdf;

%k = length(x); 
n = length(Y); T = n/N;
dx = x(2)-x(1);

nn = N*(T-1);
%y = reshape(diff(reshape(Y,T,N)),nn,1);
Z = reshape(X,T,N);
Z = [reshape(Z(2:T,:),nn, 1) reshape(Z(1:T-1,:),nn,1)]; % (X_it, X_i,t-1)
if sa
    n1 = 2*nn;
else
    n1 = nn;
end

% estimate lamda1
stdx = std(X);
h0 = 1.05*stdx/n1^(1/5);
dxx = dx/2;
x1 = prctile(X,1); x2 = prctile(X,99);
xx = (x1:dxx:x2)';
[f,f1,tmp1,tmp2,tmp3,ssr] = fdll(Y,X,N,xx,h0,sa);
s2 = ssr/n;
f2 = diff(f1)/dxx;
f2 = f2 - mean(f2);
lamda1 = trapz(f2.^2)*dxx;

% estimate lamda2
h1 = 1.05*stdx/n^(1/5);
h2 = 1.05*stdx/nn^(1/6);

w2 = feval(kernel,(repmat(Z(:,2),n,1)-kron(X,ones(nn,1)))/h1)/h1;
pv = mean(reshape(w2,nn,n),2).^2;

w = feval(kernel,(repmat(Z(:,1),nn,1)-kron(Z(:,1),ones(nn,1)))/h2)/h2 .* feval(kernel,(repmat(Z(:,2),nn,1)-kron(Z(:,2),ones(nn,1)))/h2)/h2;
p2 = mean(reshape(w,nn,nn),2).^2;

lam = pv./p2;
lamda2 = mean(lam(p2>1e-5));

% estimate ||K||,mu2(K)
dxx = 0.05;
xx = (-5:dxx:5)';
%xx = [ [-50:-1]'*dx+x1;x;x2+[1:50]'*dx ];
norm2k = trapz(feval(kernel,xx).^2)*dxx;
mu2 = trapz(feval(kernel,xx).*xx.^2)*dxx;

h = ( 2*norm2k*s2/mu2^2 * lamda2/lamda1 )^(1/5) * n1^(-1/5);



