function h = fdllh2(Y,X,N,x,sa)
% This is to find feasible optimal window width
%
if (nargin < 5 | isempty(sa)) %
    sa = 0;
end
kernel = @normpdf;
k = length(x); n = length(Y); T = n/N;
x1=x(1); x2=x(k); dx = x(2)-x(1);

nn = (N-1)*(T-1);
Z = reshape(X,T,N);
Z = [reshape(Z(2:T,2:N),(T-1)*(N-1), 1) reshape(Z(1:T-1,2:N),(T-1)*(N-1),1)...
        reshape(Z(2:T,1:N-1),(T-1)*(N-1),1) reshape(Z(1:T-1,1:N-1),(T-1)*(N-1),1)]; % (X_it, X_i,t-1)
if sa
    n1 = 4*nn;
else
    n1 = nn;
end

% estimate lamda1
stdx = std(X);
h0 = 1.05*stdx/n^(1/5);
dxx = dx/3;
x1 = prctile(X,1); x2 = prctile(X,99);
xx = (x1:dxx:x2)';
[f,f1,tmp1,tmp2,ssr] = fdll2(Y,X,N,xx,h0,sa);
s2 = ssr/n;
f2 = diff(f1)/dxx;
lamda1 = trapz(f2.^2)*dxx;

% estimate lamda2
h1 = 1.05*stdx/nn^(1/7);
h2 = 1.05*stdx/nn^(1/8);
w2 = prod(feval(kernel,(repmat(Z(:,2:4),nn,1)-kron(Z(:,2:4),ones(nn,1)))/h1),2)/h1^3;
w = feval(kernel,(repmat(Z(:,1),nn,1)-kron(Z(:,1),ones(nn,1)))/h2)/h2 .* prod(feval(kernel,(repmat(Z(:,2:4),nn,1)-kron(Z(:,2:4),ones(nn,1)))/h2),2)/h2^3;
pv = mean(reshape(w2,nn,nn),2).^2;
p2 = mean(reshape(w,nn,nn),2).^2;
lam = pv ./ p2;
lamda2 = mean(lam(p2>1e-5));
%lamda2 = mean(lam);

% estimate ||K||,mu2(K)
dxx = 0.01;
xx = [-5:dxx:5]';
norm2k = trapz(feval(kernel,xx).^2)*dxx;
mu2 = trapz(feval(kernel,xx).*xx.^2)*dxx;

h = ( 4*norm2k*s2/mu2^2 * lamda2/lamda1 )^(1/5) * n1^(-1/5) * stdx;



