function h = fdllh2(Y,X,N,x,sa)
% This is to find feasible optimal window width
%
if (nargin < 5 | isempty(sa)) %
    sa = 1;
end
kernel = @normpdf;
k = length(x); n = length(Y); T = n/N;
%x1=x(1); x2=x(k); 
dx = x(2)-x(1);

nn = N*(T-1);
y = reshape(Y,T,N);
y11 = y(2:T,2:N); y10 = y(1:T-1,2:N); y01=y(2:T,1:N-1); y00 = y(1:T-1,1:N-1);
y = reshape((y11-y10) - (y01-y00), (T-1)*(N-1), 1);
Z = reshape(X,T,N);
Z = [reshape(Z(2:T,2:N),(T-1)*(N-1), 1) reshape(Z(1:T-1,2:N),(T-1)*(N-1),1)...
        reshape(Z(2:T,1:N-1),(T-1)*(N-1),1) reshape(Z(1:T-1,1:N-1),(T-1)*(N-1),1)]; % (X_it, X_i,t-1)
if sa
%    y = [y;y;-y;-y]; Z = [Z;[Z(:,4) Z(:,3) Z(:,2) Z(:,1)];[Z(:,2) Z(:,1) Z(:,4) Z(:,3)];[Z(:,3) Z(:,4) Z(:,1) Z(:,2)]]; % sample augmentation
    n1 = 4*nn;
else
    n1 = nn;
end

% estimate lamda1
stdx = std(X);
h1 = 1.05*stdx/n1^(1/5);
dxx = dx/3;
x1 = prctile(X,1); x2 = prctile(X,99);
xx = (x1:dxx:x2)';
[f,f1,tmp1,tmp2,ssr] = fdll2(Y,X,N,xx,h1,sa);
s2 = ssr/n;
f2 = diff(f1)/dxx;
lamda1 = trapz(f2.^2)*dxx;

% estimate lamda2
xx = (x1:dxx:x2)';
p = kestpdf(X,xx);
lamda2 = trapz(1./p)*dxx;

% estimate ||K||,mu2(K)
dxx = 0.01;
xx = [-5:dxx:5]';
norm2k = trapz(feval(kernel,xx).^2)*dxx;
mu2 = trapz(feval(kernel,xx).*xx.^2)*dxx;

h = ( 4*norm2k*s2/mu2^2 * lamda2/lamda1 )^(1/5) * n1^(-1/5);



