function h = fdllhiid(Y,X,N,x,sa)
% This is to find feasible optimal window width
%
if (nargin < 5 || isempty(sa)) %
    sa = 1;
end
kernel = @normpdf;

n = length(Y); T = n/N;
%x1=x(1); x2=x(k); 
dx = x(2)-x(1);

nn = N*(T-1);
if sa
    n1 = 2*nn;
else
    n1 = nn;
end

% estimate lamda1
stdx = std(X);
h1 = 1.05*stdx/n1^(1/5);
dxx = dx/3;
x1 = prctile(X,1); x2 = prctile(X,99);
xx = (x1:dxx:x2)';
[f,f1,tmp1,tmp2,tmp3,ssr] = fdll(Y,X,N,xx,h1,sa);
s2 = ssr/n;
f2 = diff(f1)/dxx;
lamda1 = trapz(f2.^2)*dxx;

% estimate lamda2
%xx = [x1:dxx:x2]';
p = kestpdf(X,xx);
lamda2 = trapz(1./p)*dxx;

% estimate ||K||,mu2(K)
dxx = 0.01;
xx = [-5:dxx:5]';
%xx = [ [-50:-1]'*dx+x1;x;x2+[1:50]'*dx ];
norm2k = trapz(feval(kernel,xx).^2)*dxx;
mu2 = trapz(feval(kernel,xx).*xx.^2)*dxx;

h = ( 2*norm2k*s2/mu2^2 * lamda2/lamda1 )^(1/5) * n1^(-1/5);



