function takealook1()

N = 50; T = 5;
x1=-2; x2=2; dx = 0.1;
x = [x1:dx:x2]';
k = length(x);
sigma = 0.5;

M = 3;

f1 = zeros(k,M);
f2 = zeros(k,M);
f3 = zeros(k,M);
f4 = zeros(k,M);

for m = 1:M
    f1(:,m) = takealook(N,T,x,sigma,@fun1);
    f2(:,m) = takealook(N,T,x,sigma,@fun2);
    f3(:,m) = takealook(N,T,x,sigma,@fun3);
    f4(:,m) = takealook(N,T,x,sigma,@fun4);
end
f10 = feval(@fun1,x);
f20 = feval(@fun2,x);
f30 = feval(@fun3,x);
f40 = feval(@fun4,x);

f1a = f10 - trapz(f10)*dx/(x2-x1);
f2a = f20 - trapz(f20)*dx/(x2-x1);
f3a = f30 - trapz(f30)*dx/(x2-x1);
f4a = f40 - trapz(f40)*dx/(x2-x1);

figure, 
subplot(221),plot(x,f1a,'b-','LineWidth',2), hold; title('f_1'); box off;
plot(x,f1,'r-'),hold off;
subplot(222),plot(x,f2a,'b-','LineWidth',2), hold; title('f_2'); box off;
plot(x,f2,'r-'),hold off;
subplot(223),plot(x,f3a,'b-','LineWidth',2), hold; title('f_3'); box off;
plot(x,f3,'r-'),hold off; xlabel('x')
subplot(224),plot(x,f4a,'b-','LineWidth',2), hold; title('f_4'); box off;
plot(x,f4,'r-'),hold off; xlabel('x')

ise1 = zeros(M,1);
ise2 = zeros(M,1);
ise3 = zeros(M,1);
ise4 = zeros(M,1);
for i = 1:M
    ise1(i) = trapz((f1(:,i)-f1a).^2)*dx;
    ise2(i) = trapz((f2(:,i)-f2a).^2)*dx;
    ise3(i) = trapz((f3(:,i)-f3a).^2)*dx;
    ise4(i) = trapz((f4(:,i)-f4a).^2)*dx;
end

disp('MISE')
disp([mean([ise1 ise2 ise3 ise4])])

function f=fun1(x)
f = -x.^2/2;
function f=fun2(x)
f=x.*cos(pi*x);
function f=fun3(x)
f=x + 2*exp(-16*x.^2);
function f=fun4(x)
f=sin(2*x) + 2*exp(-16*x.^2);
